(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path", "./executions"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path_1 = require("path");
    var executions_1 = require("./executions");
    module.exports = {
        "SlKarma": require("./integrations/karma/index"),
        "SlWebpackPlugin": require("./integrations/webpack/plugin").SlWebpackPlugin,
        version: getCurrentVersion(),
        createBuildSessionId: executions_1.createBuildSessionId,
        runCIA: executions_1.runCIA,
        runMocha: executions_1.runMocha,
        runTestListener: executions_1.runTestListener,
        startTestExecution: executions_1.startTestExecution,
        endTestExecution: executions_1.endTestExecution,
        uploadReports: executions_1.uploadReports,
        nycReport: executions_1.nycReport,
        updateIntegrationBuildComponents: executions_1.updateIntegrationBuildComponents,
        deleteIntegrationBuildComponents: executions_1.deleteIntegrationBuildComponents
    };
    function getCurrentVersion() {
        var rootFolder = path_1.resolve(__dirname, "..");
        if (rootFolder.indexOf("tsOutputs") > -1) {
            rootFolder = path_1.resolve(rootFolder, "..");
        }
        var packageJsonPath = path_1.resolve(rootFolder, "package.json");
        return require(packageJsonPath).version;
    }
});
//# sourceMappingURL=api.js.map