var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./utils", "./sl-cia-proxy", "./object-factory", "sl-node2", "path", "./entities-mapper", "sl-js-infra", "fs", "./folder-restore", "./logger", "./agent-instance-data"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils_1 = require("./utils");
    var sl_cia_proxy_1 = require("./sl-cia-proxy");
    var object_factory_1 = require("./object-factory");
    var Slnode2 = require("sl-node2");
    var path = require("path");
    var entities_mapper_1 = require("./entities-mapper");
    var sl_js_infra_1 = require("sl-js-infra");
    var fs = require("fs");
    var folder_restore_1 = require("./folder-restore");
    var logger_1 = require("./logger");
    var agent_instance_data_1 = require("./agent-instance-data");
    var DEFAULT_NYC_REPORT_FILE_NAME = "coverage-final.json";
    var COVERAGE_FOLDER = "coverage";
    var DEFAULT_NYC_REPORT_FILE_LOC = path.resolve(".", COVERAGE_FOLDER, DEFAULT_NYC_REPORT_FILE_NAME);
    var AsyncExecutionApi = /** @class */ (function () {
        function AsyncExecutionApi() {
            this.logger = logger_1.LoggerFactory.getCreateApplicationLogger();
            this.utils = new utils_1.Utils();
            this.spawnRuntimeArgs = this.utils.getSpawnNodeArgs();
            this.dependencies = this.utils.deps();
        }
        AsyncExecutionApi.prototype.defaultCallback = function (err) {
            if (err) {
                console.log(err);
            }
        };
        ;
        AsyncExecutionApi.prototype.createConfig = function (args, callback) {
            callback = callback || this.defaultCallback;
            var proxy = new sl_cia_proxy_1.SlCiaProxy();
            proxy.config(args, callback);
        };
        AsyncExecutionApi.prototype.createBuild = function (args, callback) {
            callback = callback || this.defaultCallback;
            var proxy = new sl_cia_proxy_1.SlCiaProxy();
            this.utils.saveConfigurationToProcessEnv(args);
            proxy.build(args, callback);
        };
        AsyncExecutionApi.prototype.runMocha = function (cmdArgs, mochaArgs, callback) {
            var _this = this;
            callback = callback || this.defaultCallback;
            this.utils.configTestFramework(cmdArgs, function (err) {
                var statusCode = 0;
                if (err) {
                    statusCode = err.statusCode || 1;
                }
                else {
                    _this.utils.runSlNodeCoverWithMocha2(mochaArgs, _this.dependencies.slNode2Path, _this.dependencies.slNodeMocha2Path, _this.spawnRuntimeArgs, cmdArgs);
                }
            });
        };
        AsyncExecutionApi.prototype.runJasmine = function (cmdArgs, jasmineArgs) {
            var _this = this;
            this.utils.configTestFramework(cmdArgs, function (err) {
                var statusCode = 0;
                if (err) {
                    throw new Error("Failed running Jasmine. An error occurred during configuration. Error:" + err);
                }
                _this.utils.runSlNodeCoverWithJasmine(jasmineArgs, _this.spawnRuntimeArgs);
            });
        };
        AsyncExecutionApi.prototype.runMochaPhantomJS = function (cmdArgs, callback) {
            callback = callback || this.defaultCallback;
            var mochaPhantomJS = object_factory_1.ObjectFactory.createMochaPhantomJs(cmdArgs);
            mochaPhantomJS.integrate(cmdArgs, function (err) {
                var statusCode = 0;
                if (err) {
                    statusCode = err.statusCode || 1;
                }
                callback(statusCode);
            });
        };
        AsyncExecutionApi.prototype.run = function (cmdArgs, runArgs, callback) {
            var _this = this;
            callback = callback || this.defaultCallback;
            try {
                this.utils.validateRequiredParams(cmdArgs, [], [
                    ["token", "tokenfile"],
                    ["buildsessionid", "buildsessionidfile"]
                ]);
                var buildSessionId = this.utils.getBuildSession(cmdArgs);
                this.utils.parseAndGetParams(cmdArgs, buildSessionId, function (err) {
                    if (err) {
                        throw err;
                    }
                    if (!cmdArgs.labid) {
                        cmdArgs.labid = buildSessionId;
                    }
                    _this.utils.saveConfigurationToProcessEnv(cmdArgs);
                    _this.utils.runSlNode2(runArgs, _this.dependencies.slNode2Path, _this.spawnRuntimeArgs, cmdArgs);
                });
            }
            catch (err) {
                callback(err);
            }
        };
        AsyncExecutionApi.prototype.startExecution = function (args, callback) {
            this.submitSlnode2ApiRequest(args, RequestType.START, [], [], callback);
        };
        AsyncExecutionApi.prototype.endExecution = function (args, callback) {
            this.submitSlnode2ApiRequest(args, RequestType.END, [], [], callback);
        };
        AsyncExecutionApi.prototype.uploadReports = function (args, callback) {
            this.submitSlnode2ApiRequest(args, RequestType.UPLOAD_REPORT, [], ["reportFile", "reportFilesFolder"], callback);
        };
        AsyncExecutionApi.prototype.externalReport = function (args, callback) {
            this.submitSlnode2ApiRequest(args, RequestType.EXTERNAL_REPORT, ["report"], [], callback);
        };
        AsyncExecutionApi.prototype.nycReport = function (args, callback) {
            this.submitSlnode2ApiRequest(args, RequestType.NYC_REPORT, [], [], callback);
        };
        AsyncExecutionApi.prototype.submitSlnode2ApiRequest = function (args, requestType, requiredParams, requiredLists, callback) {
            var _this = this;
            callback = callback || this.defaultCallback;
            var defaultRequiredLists = [
                ["token", "tokenfile"],
                ["buildsessionid", "buildsessionidfile"],
            ];
            if (requiredLists && requiredLists.length > 0) {
                defaultRequiredLists.push(requiredLists);
            }
            requiredParams = requiredParams || [];
            try {
                this.utils.validateRequiredParams(args, requiredParams, defaultRequiredLists);
                var buildSessionId = this.utils.getBuildSession(args);
            }
            catch (err) {
                return callback(err);
            }
            this.utils.parseAndGetParams(args, buildSessionId, function (err) { return __awaiter(_this, void 0, void 0, function () {
                var agentEventsController, shutdownCallback, _a, httpConfig, request, agentData, report, data, agentConfig;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (err) {
                                return [2 /*return*/, callback(err)];
                            }
                            if (!args.labid) {
                                args.labid = buildSessionId;
                            }
                            agentEventsController = this.createAgentEventsController(args);
                            shutdownCallback = function (err) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, agentEventsController.submitAgentShutdownEvent()];
                                        case 1:
                                            _a.sent();
                                            callback(err);
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            return [4 /*yield*/, agentEventsController.submitAgentStartedEvent()];
                        case 1:
                            _b.sent();
                            _a = this.createRequest(args, requestType), httpConfig = _a.httpConfig, request = _a.request;
                            switch (requestType) {
                                case RequestType.END:
                                    Slnode2.endExecution(request, httpConfig, shutdownCallback);
                                    break;
                                case RequestType.START:
                                    Slnode2.startExecution(request, httpConfig, shutdownCallback);
                                    break;
                                case RequestType.EXTERNAL_REPORT:
                                    report = fs.readFileSync(args.report, "utf-8");
                                    data = JSON.parse(report);
                                    agentData = entities_mapper_1.EntitiesMapper.toExternalReportData(request, data);
                                    Slnode2.externalReport(request, httpConfig, agentData, shutdownCallback);
                                    break;
                                case RequestType.UPLOAD_REPORT:
                                    agentData = entities_mapper_1.EntitiesMapper.toAgentData(request);
                                    Slnode2.uploadReports(request, httpConfig, agentData, shutdownCallback);
                                    break;
                                case RequestType.NYC_REPORT:
                                    args.report = args.report || DEFAULT_NYC_REPORT_FILE_LOC;
                                    agentConfig = this.utils.createAgentConfig(args);
                                    Slnode2.uploadNycReport(args.report, agentConfig);
                                    shutdownCallback(null);
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        };
        AsyncExecutionApi.prototype.restoreFolder = function (args, callback) {
            callback = callback || this.defaultCallback;
            var folderRestore = new folder_restore_1.FolderRestore(args.folderToRestore);
            try {
                folderRestore.restore();
                callback(null);
            }
            catch (err) {
                callback(err);
            }
        };
        AsyncExecutionApi.prototype.createRequest = function (args, requestType) {
            var agentConfig = this.utils.createAgentConfig(args);
            var httpConfig = entities_mapper_1.EntitiesMapper.toHttpClientConfig(agentConfig);
            var request;
            request = this.mapRequest(requestType, agentConfig, args);
            return { httpConfig: httpConfig, request: request };
        };
        AsyncExecutionApi.prototype.mapRequest = function (requestType, agentConfig, args) {
            var request;
            switch (requestType) {
                case RequestType.START:
                    request = entities_mapper_1.EntitiesMapper.toStartExecutionRequest(agentConfig, args.teststage);
                    break;
                case RequestType.END:
                    request = entities_mapper_1.EntitiesMapper.toEndExecutionRequest(agentConfig);
                    break;
                case RequestType.UPLOAD_REPORT:
                case RequestType.EXTERNAL_REPORT:
                    request = entities_mapper_1.EntitiesMapper.toUploadReportRequest(agentConfig, args);
                    break;
            }
            return request;
        };
        AsyncExecutionApi.prototype.createAgentEventsController = function (cmd) {
            var agentConfig = this.utils.createAgentConfig(cmd);
            return new sl_js_infra_1.SlJsInfra.AgentEventsController(agentConfig, agent_instance_data_1.agentInstanceData, false, this.logger);
        };
        return AsyncExecutionApi;
    }());
    exports.AsyncExecutionApi = AsyncExecutionApi;
    var RequestType;
    (function (RequestType) {
        RequestType["START"] = "start";
        RequestType["END"] = "end";
        RequestType["UPLOAD_REPORT"] = "uploadReport";
        RequestType["EXTERNAL_REPORT"] = "externalReport";
        RequestType["NYC_REPORT"] = "nycReport";
    })(RequestType || (RequestType = {}));
});
//# sourceMappingURL=async-execution-api.js.map