(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "sl-js-infra"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var sl_js_infra_1 = require("sl-js-infra");
    var ConfigurationManager = /** @class */ (function () {
        function ConfigurationManager() {
        }
        ConfigurationManager.prototype.convertConfigParams = function (config) {
            var convertedConfig = {};
            Object.assign(convertedConfig, config);
            convertedConfig.tokenfile = convertedConfig.tokenfile || convertedConfig.tokenFile;
            convertedConfig.buildsessionid = convertedConfig.buildsessionid || convertedConfig.buildSessionId;
            convertedConfig.buildsessionidfile = convertedConfig.buildsessionidfile || convertedConfig.buildSessionIdFile;
            convertedConfig.failbuild = convertedConfig.failbuild || false;
            convertedConfig.teststage = convertedConfig.teststage || convertedConfig.testStage || "Unit Tests";
            convertedConfig.labid = convertedConfig.labid || convertedConfig.labId || convertedConfig.buildsessionid;
            return convertedConfig;
        };
        ConfigurationManager.prototype.getSealightsConfiguration = function () {
            var configLoader = new sl_js_infra_1.SlJsInfra.ConfigLoader();
            var agentCfg = configLoader.loadAgentConfiguration({});
            return agentCfg;
        };
        return ConfigurationManager;
    }());
    exports.ConfigurationManager = ConfigurationManager;
});
//# sourceMappingURL=configuration-manager.js.map