(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    /*
        In cli we use commander module which responsible to parse options that passed to command, (i.e. --buildsessionId).
        to find matching it use 'is' function which is case sensitive, so we override the function to achieve case insensitivity.
     */
    var program = require("commander");
    var CustomCommander = /** @class */ (function () {
        function CustomCommander() {
            this.commander = program;
            this.overrideIsFunc();
        }
        CustomCommander.prototype.overrideIsFunc = function () {
            var customOption = this.commander.Option;
            customOption.prototype.is = function (arg) {
                if (this.short && this.long) {
                    return arg.toLowerCase() == this.short.toLowerCase() || arg.toLowerCase() == this.long.toLowerCase();
                }
                if (this.long && !this.short) {
                    return arg.toLowerCase() == this.long.toLowerCase();
                }
                return false;
            };
        };
        CustomCommander.prototype.getCommander = function () {
            return this.commander;
        };
        return CustomCommander;
    }());
    exports.CustomCommander = CustomCommander;
});
//# sourceMappingURL=custom-commander.js.map