(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./file-utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var FileUtils = require("./file-utils");
    function tryGetDefaultFile(filename, workspacepath, logger) {
        var defaultFile = FileUtils.findFileInFolder(filename, process.cwd(), logger);
        if (defaultFile) {
            return defaultFile;
        }
        if (workspacepath) {
            defaultFile = FileUtils.findFileInFolder(filename, workspacepath, logger);
            if (defaultFile) {
                return defaultFile;
            }
        }
        logger.info("Cannot find default token file");
        return null;
    }
    exports.tryGetDefaultFile = tryGetDefaultFile;
});
//# sourceMappingURL=default-file-utils.js.map