(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var EntitiesMapper = /** @class */ (function () {
        function EntitiesMapper() {
        }
        EntitiesMapper.toHttpClientConfig = function (agentConfig) {
            var config = {
                token: agentConfig.token.value,
                proxy: agentConfig.proxy.value,
                server: agentConfig.server.value,
                compressRequests: agentConfig.gzip.value
            };
            return config;
        };
        EntitiesMapper.toStartExecutionRequest = function (agentConfig, testPhase) {
            var result = {
                appName: agentConfig.appName.value,
                buildName: agentConfig.build.value,
                branchName: agentConfig.branch.value,
                customerId: agentConfig.customerId.value,
                environment: (agentConfig.labId.value || agentConfig.environmentName.value || agentConfig.appName.value),
                testStage: testPhase,
                newEnvironment: testPhase
            };
            return result;
        };
        EntitiesMapper.toEndExecutionRequest = function (agentConfig) {
            var result = {
                customerId: agentConfig.customerId.value,
                appName: agentConfig.appName.value,
                buildName: agentConfig.build.value,
                branchName: agentConfig.branch.value,
                environment: (agentConfig.labId.value || agentConfig.environmentName.value || agentConfig.appName.value),
            };
            return result;
        };
        EntitiesMapper.toUploadReportRequest = function (agentConfig, cliArgs) {
            var result = {
                appName: agentConfig.appName.value,
                customerId: agentConfig.customerId.value,
                server: agentConfig.server.value,
                proxy: agentConfig.proxy.value,
                labId: agentConfig.labId.value,
                build: agentConfig.build.value,
                branch: agentConfig.branch.value,
                isValidToken: (agentConfig.token.hasValue || agentConfig.tokenFile.hasValue),
                reportFile: cliArgs.reportFile,
                reportFilesFolder: cliArgs.reportFilesFolder,
                type: cliArgs.type,
                source: cliArgs.source,
                hasMoreRequests: cliArgs.hasMoreRequests
            };
            return result;
        };
        EntitiesMapper.toAgentData = function (request) {
            var result = {
                customerId: request.customerId,
                appName: request.appName,
                environment: {
                    labId: request.labId,
                    environmentName: request.labId //TODO: this field should be deprecated
                },
                type: request.type,
                source: request.source,
                hasMoreRequests: request.hasMoreRequests,
                buildName: request.build,
                branchName: request.branch
            };
            return result;
        };
        EntitiesMapper.toExternalReportData = function (request, data) {
            data.appName = request.appName;
            data.buildName = request.build;
            data.branchName = request.branch;
            return data;
        };
        return EntitiesMapper;
    }());
    exports.EntitiesMapper = EntitiesMapper;
});
//# sourceMappingURL=entities-mapper.js.map