/*
    This class managed all environment data for sealights configuration.
 */
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./constants"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var constants_1 = require("./constants");
    var os = require("os");
    var EnvironmentParams = /** @class */ (function () {
        function EnvironmentParams() {
        }
        EnvironmentParams.prototype.getBasePath = function () {
            return process.env[constants_1.Constants.SL_ENV_VARS.BASE_PATH] || process.cwd();
        };
        EnvironmentParams.prototype.getFileStorage = function () {
            return process.env[constants_1.Constants.SL_ENV_VARS.FILE_STORAGE] || os.tmpdir();
        };
        return EnvironmentParams;
    }());
    exports.EnvironmentParams = EnvironmentParams;
});
//# sourceMappingURL=environment-params.js.map