var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "sl-js-infra", "./logger", "fs", "./sl-cia-proxy", "./utils", "sl-node2", "./agent-instance-data"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var sl_js_infra_1 = require("sl-js-infra");
    var BackendProxy = sl_js_infra_1.SlJsInfra.BackendProxy;
    var logger_1 = require("./logger");
    var fs_1 = require("fs");
    var sl_cia_proxy_1 = require("./sl-cia-proxy");
    var utils_1 = require("./utils");
    var sl_node2_1 = require("sl-node2");
    var agent_instance_data_1 = require("./agent-instance-data");
    var logger = logger_1.LoggerFactory.getCreateApplicationLogger();
    function createBuildSessionId(config, args) {
        return __awaiter(this, void 0, void 0, function () {
            var backendProxy, buildSessionId, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backendProxy = new BackendProxy(agent_instance_data_1.agentInstanceData, config, logger);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, backendProxy.createBuildSessionIdPromise(args)];
                    case 2:
                        buildSessionId = _a.sent();
                        fs_1.writeFileSync("buildSessionId", buildSessionId);
                        console.log("Build Session Id Created Successfully In buildSessionId File. Build Session Id: " + buildSessionId);
                        return [2 /*return*/, true];
                    case 3:
                        e_1 = _a.sent();
                        console.error("Error while trying to create build session id. error: " + e_1);
                        return [2 /*return*/, false];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    exports.createBuildSessionId = createBuildSessionId;
    function runCIA(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        var slCiaProxy = new sl_cia_proxy_1.SlCiaProxy();
                        slCiaProxy.runCia(args, function (err) {
                            var command = "build";
                            err == null ? logSuccess(command) : logFailure(command, err);
                            resolve(err == null);
                        });
                    })];
            });
        });
    }
    exports.runCIA = runCIA;
    function runMocha(args, mochaArgs) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, reportAgentEvents(args)];
                    case 1:
                        _a.sent();
                        new utils_1.Utils().runMocha(args, mochaArgs);
                        return [2 /*return*/];
                }
            });
        });
    }
    exports.runMocha = runMocha;
    function runTestListener(args, extraParams) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, reportAgentEvents(args)];
                    case 1:
                        _a.sent();
                        new utils_1.Utils().runTestListener(args, extraParams);
                        return [2 /*return*/];
                }
            });
        });
    }
    exports.runTestListener = runTestListener;
    function startTestExecution(config, request, agentConfig) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, runSlnodeFunction(agentConfig, sl_node2_1.startExecution, request, config)];
            });
        });
    }
    exports.startTestExecution = startTestExecution;
    function endTestExecution(config, request, agentConfig) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, runSlnodeFunction(agentConfig, sl_node2_1.endExecution, request, config)];
            });
        });
    }
    exports.endTestExecution = endTestExecution;
    function uploadReports(config, request, agentData, agentConfig) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, runSlnodeFunction(agentConfig, sl_node2_1.uploadReports, request, config, agentData)];
            });
        });
    }
    exports.uploadReports = uploadReports;
    function runSlnodeFunction(agentConfig, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var agentEventsController;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        agentEventsController = createAgentEventsController(agentConfig);
                        return [4 /*yield*/, agentEventsController.submitAgentStartedEvent()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve) {
                                var callBack = function (err) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, agentEventsController.submitAgentShutdownEvent()];
                                            case 1:
                                                _a.sent();
                                                err == null ? logSuccess(func.name) : logFailure(func.name, err);
                                                resolve(err == null);
                                                return [2 /*return*/];
                                        }
                                    });
                                }); };
                                args.push(callBack);
                                func.apply(null, args);
                            }).catch(function (err) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            logFailure(func.name, err);
                                            return [4 /*yield*/, agentEventsController.submitAgentShutdownEvent()];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                }
            });
        });
    }
    function updateIntegrationBuildComponents(config, args) {
        return __awaiter(this, void 0, void 0, function () {
            var backendProxy, components;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backendProxy = new BackendProxy(agent_instance_data_1.agentInstanceData, config, logger);
                        components = getIntegrationBuildDependenciesFromArgs(args);
                        if (!(components.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, backendProxy.addOrUpdateIntegrationBuildComponents(args.buildSessionId, components, agent_instance_data_1.agentInstanceData.agentId)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, true];
                    case 2:
                        logger.info("No components were passed");
                        return [2 /*return*/, false];
                }
            });
        });
    }
    exports.updateIntegrationBuildComponents = updateIntegrationBuildComponents;
    function deleteIntegrationBuildComponents(config, args) {
        return __awaiter(this, void 0, void 0, function () {
            var backendProxy, components;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backendProxy = new BackendProxy(agent_instance_data_1.agentInstanceData, config, logger);
                        components = getIntegrationBuildDependenciesFromArgs(args);
                        if (!(components.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, backendProxy.deleteIntegrationBuildComponents(args.buildSessionId, components, agent_instance_data_1.agentInstanceData.agentId)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, true];
                    case 2:
                        logger.info("No components were passed");
                        return [2 /*return*/, false];
                }
            });
        });
    }
    exports.deleteIntegrationBuildComponents = deleteIntegrationBuildComponents;
    function getIntegrationBuildDependenciesFromArgs(integrationBuildUpdateArgs) {
        try {
            var deps = [];
            if (integrationBuildUpdateArgs.componentIds) {
                deps = sl_js_infra_1.SlJsInfra.DependencyUtils.parseDependencies(integrationBuildUpdateArgs.componentIds, logger);
            }
            else if (integrationBuildUpdateArgs.componentFile) {
                var depsFile = parseJsonFile(integrationBuildUpdateArgs.componentFile);
                deps = sl_js_infra_1.SlJsInfra.DependencyUtils.parseDependenciesFile(depsFile, logger);
            }
            ;
            //Convert from IBuildDependency(appName, branch, build) to IBuildDependency (appName, branchName, buildName), 
            // as requried by backendProxy.addOrUpdateIntegrationBuildComponents/deleteIntegrationBuildComponents
            return deps.map(function (dep) {
                var mappedDependency = {};
                if (dep.appName)
                    mappedDependency.appName = dep.appName;
                if (dep.branch)
                    mappedDependency.branchName = dep.branch;
                if (dep.build)
                    mappedDependency.buildName = dep.build;
                if (dep.buildSessionId)
                    mappedDependency.buildSessionId = dep.buildSessionId;
                return mappedDependency;
            });
        }
        catch (err) {
            logger.error("Error parsing dependencies", err);
            return [];
        }
    }
    function parseJsonFile(filename) {
        var rawFile;
        try {
            rawFile = fs_1.readFileSync(filename).toString();
        }
        catch (err) {
            logger.error("Error reading file " + filename, err);
            throw err;
        }
        try {
            return JSON.parse(rawFile);
        }
        catch (err) {
            logger.error("Error parsing JSON file " + filename, err);
            throw err;
        }
    }
    function nycReport(reportFile, config) {
        return __awaiter(this, void 0, void 0, function () {
            var agentEventsController, agentConfig, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        agentEventsController = createAgentEventsController(config);
                        return [4 /*yield*/, agentEventsController.submitAgentStartedEvent()];
                    case 1:
                        _a.sent();
                        agentConfig = new utils_1.Utils().createAgentConfig(config);
                        result = sl_node2_1.uploadNycReport(reportFile, agentConfig);
                        return [4 /*yield*/, agentEventsController.submitAgentShutdownEvent()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    }
    exports.nycReport = nycReport;
    function createAgentEventsController(cmdArgs) {
        var agentConfig = new utils_1.Utils().createAgentConfig(cmdArgs);
        return new sl_js_infra_1.SlJsInfra.AgentEventsController(agentConfig, agent_instance_data_1.agentInstanceData, false, logger);
    }
    /*
        Test listener commands (run/mocha) are spawning new process so original process.argv not reported.
        Here both start and end events reported immediately in order to get tha original data
     */
    function reportAgentEvents(args) {
        return __awaiter(this, void 0, void 0, function () {
            var agentEventsController;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        agentEventsController = createAgentEventsController(args);
                        return [4 /*yield*/, agentEventsController.submitAgentStartedEvent()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, agentEventsController.submitAgentShutdownEvent()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function logSuccess(command) {
        console.log("Command " + command + " finished successfully");
    }
    function logFailure(command, err) {
        console.error("Failed to execute command '" + command + "'. Error: " + err);
    }
});
//# sourceMappingURL=executions.js.map