(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./user-message-helper", "./babel-config-manager", "./nyc-config-manager", "./environment-params"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var user_message_helper_1 = require("./user-message-helper");
    var babel_config_manager_1 = require("./babel-config-manager");
    var nyc_config_manager_1 = require("./nyc-config-manager");
    var environment_params_1 = require("./environment-params");
    /*
        This class managed all customisation for sealights eazy installation.
     */
    var DEFAULT_NODE_ENV_VALUE = ["test"];
    var InstallationManager = /** @class */ (function () {
        function InstallationManager() {
        }
        InstallationManager.prototype.updateBabelConfig = function (cmd, logger) {
            var environmentParams = new environment_params_1.EnvironmentParams();
            var userMessageHelper = new user_message_helper_1.UserMessageHelper("Sealights babel installer");
            var nodeEnvValues = cmd.nodeEnvValue || DEFAULT_NODE_ENV_VALUE;
            var babelConfigManager = new babel_config_manager_1.BabelConfigManager(userMessageHelper, environmentParams, nodeEnvValues, logger);
            var nycConfigManager = new nyc_config_manager_1.NycConfigManager(userMessageHelper, environmentParams, logger);
            var babelUpdated = babelConfigManager.tryUpdate();
            var nycUpdated = nycConfigManager.tryUpdate();
            if (babelUpdated && nycUpdated)
                userMessageHelper.println("Babel configuration successfully updated. Please set 'NODE_ENV' value where needed.");
        };
        return InstallationManager;
    }());
    exports.InstallationManager = InstallationManager;
});
//# sourceMappingURL=installation-manager.js.map