(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "fs", "../commons/browser-agent-instrumentor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fs = require("fs");
    var browser_agent_instrumentor_1 = require("../commons/browser-agent-instrumentor");
    var SlKarmaFramework = /** @class */ (function () {
        //TODO: Make sure to create types.
        function SlKarmaFramework(config, files, logger) {
            this.logger = logger;
            this.init(files);
        }
        SlKarmaFramework.prototype.init = function (files) {
            var log = this.logger.create('sl-karma-framework');
            try {
                var instrumentedAgentPath = browser_agent_instrumentor_1.BrowserAgentInstrumentor.getInstrumentedAgentPath();
                var sourceMapPath = browser_agent_instrumentor_1.BrowserAgentInstrumentor.getSourceMapPackagePath();
                log.info("SlKarmaFramework initializing. Injecting the following scripts:\n\t[1] Browser Agent: '" + instrumentedAgentPath
                    + "'.\n\t[2] Source Map Support: '" + sourceMapPath + "'.");
                fs.closeSync(fs.openSync(instrumentedAgentPath, 'w'));
                files.unshift(this.createPattern(instrumentedAgentPath));
                files.unshift(this.createPattern(sourceMapPath));
            }
            catch (err) {
                log.error("Failed resolving sealights browser agent. Skipping sealights. Error:", err);
            }
        };
        SlKarmaFramework.prototype.createPattern = function (pattern) {
            var result = {
                pattern: pattern,
                included: true,
                served: true,
                watched: true
            };
            return result;
        };
        ;
        //This field is being used by Karma.
        SlKarmaFramework.$inject = ['config.sealights', 'config.files', 'logger'];
        return SlKarmaFramework;
    }());
    exports.SlKarmaFramework = SlKarmaFramework;
});
//# sourceMappingURL=framework.js.map