(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./preprocessor", "./framework", "./reporter", "../../utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var preprocessor_1 = require("./preprocessor");
    var framework_1 = require("./framework");
    var reporter_1 = require("./reporter");
    var utils_1 = require("../../utils");
    var preProcessorFactory = function (config, logger) {
        var preProcessor = new preprocessor_1.SlPreProcessor(config, logger);
        return preProcessor.createPreProcessingFunction(new utils_1.Utils());
    };
    var frameworkFactory = function (config, files, logger) {
        return new framework_1.SlKarmaFramework(config, files, logger);
    };
    var reporterFactory = function (config, helper, logger, emitter) {
        return new reporter_1.SlKarmaReporter(config, helper, logger, emitter);
    };
    preProcessorFactory["$inject"] = preprocessor_1.SlPreProcessor.$inject;
    frameworkFactory["$inject"] = framework_1.SlKarmaFramework.$inject;
    reporter_1.SlKarmaReporter["$inject"] = reporter_1.SlKarmaReporter.$inject;
    module.exports = {
        'reporter:sealights': ['type', reporterFactory],
        'preprocessor:sealights': ['factory', preProcessorFactory],
        'framework:sealights': ['factory', frameworkFactory]
    };
});
//# sourceMappingURL=index.js.map