var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./config-manager"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var config_manager_1 = require("./config-manager");
    /*
        This class update nyc configuration to sealights requirements
     */
    var NycConfigManager = /** @class */ (function (_super) {
        __extends(NycConfigManager, _super);
        function NycConfigManager(userMessageHelper, environmentParams, logger) {
            var _this = _super.call(this, userMessageHelper, config_manager_1.Packages.NYC, environmentParams, logger) || this;
            _this.defaultConfig = {
                "reporter": ["html"],
                "require": [
                    "babel-register"
                ],
                "sourceMap": false,
                "instrument": false
            };
            return _this;
        }
        NycConfigManager.prototype.update = function (config) {
            this.saveOriginalConfig(config);
            this.updateReporter(config);
            this.updateRequire(config);
            config.sourceMap = false;
            config.instrument = false;
            return config;
        };
        ;
        NycConfigManager.prototype.writeDefault = function () {
            return this.writeToConfigFile(this.defaultConfig);
        };
        NycConfigManager.prototype.updateReporter = function (config) {
            if (!config.reporter) {
                config.reporter = this.defaultConfig.reporter;
                return;
            }
            if (config.reporter.indexOf(this.defaultConfig.reporter[0]) == -1) {
                config.reporter.push(this.defaultConfig.reporter[0]);
            }
        };
        NycConfigManager.prototype.updateRequire = function (config) {
            if (!config.require) {
                config.require = this.defaultConfig.require;
                return;
            }
            if (config.require.indexOf(this.defaultConfig.require[0]) == -1) {
                config.require.push(this.defaultConfig.require[0]);
            }
        };
        NycConfigManager.prototype.getFileName = function () {
            return ".nycrc";
        };
        NycConfigManager.prototype.getConfigKey = function () {
            return "nyc";
        };
        NycConfigManager.prototype.tryUpdate = function () {
            try {
                var isSecceed = void 0;
                var originalConfig = this.read();
                if (!originalConfig) {
                    this.consoleLogger.println("Can't find configuration for nyc in project. default configuration will be saved to .nycrc");
                    isSecceed = this.writeDefault();
                }
                else {
                    var updatedConfig = this.update(originalConfig);
                    isSecceed = this.write(updatedConfig);
                }
                return isSecceed;
            }
            catch (err) {
                this.consoleLogger.printError("Failed to update nyc configuration - skip this phase");
                return false;
            }
        };
        ;
        return NycConfigManager;
    }(config_manager_1.ConfigManager));
    exports.NycConfigManager = NycConfigManager;
});
//# sourceMappingURL=nyc-config-manager.js.map