(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./integrations/mocha-phantomjs/mocha-phantomjs", "./integrations/commons/browser-agent-instrumentor", "./user-message-helper", "./configuration-manager"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var mocha_phantomjs_1 = require("./integrations/mocha-phantomjs/mocha-phantomjs");
    var browser_agent_instrumentor_1 = require("./integrations/commons/browser-agent-instrumentor");
    var user_message_helper_1 = require("./user-message-helper");
    var configuration_manager_1 = require("./configuration-manager");
    var ObjectFactory = /** @class */ (function () {
        function ObjectFactory() {
        }
        ObjectFactory.createMochaPhantomJs = function (cmdArgs) {
            var configurationManager = new configuration_manager_1.ConfigurationManager();
            var convertedConfig = configurationManager.convertConfigParams(cmdArgs);
            var userMessageHelper = new user_message_helper_1.UserMessageHelper("Sealights Mocha PhantomJS");
            var browserAgentInstrumentor = new browser_agent_instrumentor_1.BrowserAgentInstrumentor(convertedConfig, userMessageHelper);
            var mochaPhantomJS = new mocha_phantomjs_1.MochaPhantomJs(browserAgentInstrumentor, userMessageHelper, configurationManager);
            return mochaPhantomJS;
        };
        return ObjectFactory;
    }());
    exports.ObjectFactory = ObjectFactory;
});
//# sourceMappingURL=object-factory.js.map