var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./build-session-id-creator"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var build_session_id_creator_1 = require("./build-session-id-creator");
    /**
     * Create build session id for PR integration, from given cli arguments
     */
    var PrBuildSessionIdCreator = /** @class */ (function (_super) {
        __extends(PrBuildSessionIdCreator, _super);
        function PrBuildSessionIdCreator(cmdArgs) {
            var _this = _super.call(this, cmdArgs) || this;
            _this.latestCommit = cmdArgs.latestCommit;
            _this.repositoryUrl = cmdArgs.repositoryUrl;
            _this.pullRequestNumber = cmdArgs.pullRequestNumber;
            _this.targetBranch = cmdArgs.targetBranch;
            return _this;
        }
        PrBuildSessionIdCreator.prototype.getRequiredParams = function () {
            return ["latestCommit", "repositoryUrl", "pullRequestNumber", "targetBranch", "appname"];
        };
        PrBuildSessionIdCreator.prototype.createRequestData = function () {
            var pullRequestParams = {
                targetBranch: this.targetBranch,
                latestCommit: this.latestCommit,
                repositoryUrl: this.repositoryUrl,
                pullRequestNumber: this.pullRequestNumber
            };
            return __assign({}, _super.prototype.createRequestData.call(this), { pullRequestParams: pullRequestParams });
        };
        return PrBuildSessionIdCreator;
    }(build_session_id_creator_1.BuildSessionIdCreator));
    exports.PrBuildSessionIdCreator = PrBuildSessionIdCreator;
});
//# sourceMappingURL=pr-build-session-id-creator.js.map