var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./utils", "./async-execution-api", "./upgrade-manager", "./installation-manager", "./user-message-helper", "./logger", "./environment-params", "./custom-commander", "./pr-build-session-id-creator", "./build-session-id-creator"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var packageFile = require("../../package.json"); //This path is the correct one for the runtime, rather than development as at runtime the code is under 'tsOutputs' and not in the root.
    var utils_1 = require("./utils");
    var spawn = require('child_process').spawn;
    var async_execution_api_1 = require("./async-execution-api");
    var upgrade_manager_1 = require("./upgrade-manager");
    var installation_manager_1 = require("./installation-manager");
    var user_message_helper_1 = require("./user-message-helper");
    var logger_1 = require("./logger");
    var environment_params_1 = require("./environment-params");
    var custom_commander_1 = require("./custom-commander");
    var pr_build_session_id_creator_1 = require("./pr-build-session-id-creator");
    var build_session_id_creator_1 = require("./build-session-id-creator");
    var options = {
        "token": "Token (mandatory if tokenfile is not provided). Case-sensitive.",
        "tokenfile": "Token File (mandatory if token is not provided). case-sensitive.",
        "appname": "Application name, case-sensitive.",
        "branch": "Branch name, case-sensitive.",
        "build": "Build id, case-sensitive. Should be unique between builds.",
        "buildsessionid": "Build Session Id (mandatory if buildsessionidfile is not provided), case-sensitive.",
        "buildsessionidfile": "Build Session Id File (mandatory if buildsessionid is not provided), case-sensitive.",
        "proxy": "Proxy server (optional, must be a valid URL. in the form of 'http://127.0.0.1:3333').",
        "failbuild": "Fail Build, Flag indicating whether or not to exit with status code 1 if command fails. Default is false",
        "usebranchcoverage": "Branch Coverage, Flag indicating whether or not to collect branch cover coverage. Default is true",
        "workspacepath": "Path to the workspace where the source code exists",
        "excludedpaths": "Comma-separated list of excluded paths glob strings, in the form of 'public/**/*.js,files/**/*.js",
        "jobName": "The CI job name that triggered the build.",
        "logsUrl": "The logs url of the build.",
        "commit": "Commit ID, as provided by the SCM",
        "scm": "The Source Control Management used (currently only 'git' is supported)",
        "dependency": "Project dependencies. Pattern should be a semicolon-separated AppName@Branch@Build list.",
        "dependenciesFile": "A path to a json file that is in the following format: [{\"appName\":\"\",\"branch\":\"\",\"build\":\"\"},{...}]",
        "teststage": "The tests stage (e.g 'integration tests', 'regression'). The default will be 'Unit Tests'",
        "labid": "Lab Id, case-sensitive.",
        "useinitialcolor": "Run in generic mode for unsupported test frameworks. Default is false",
        "reportFile": "Report files. This argument can be declared multiple times in order to upload multiple files.",
        "reportFilesFolder": "Folders that contains nothing but report files. All files in folder will be uploaded. " +
            "This argument can be declared multiple times in order to upload multiple files from multiple folders.",
        "hasMoreRequests": "Flag indicating whether or not to stop execution after upload. Default is true",
        "type": "Type of test report. Default is JUnitReport",
        "source": "Source of test framework. Default is Mocha",
        "report": "Path to the relevant Sealights formatted json report.",
        "httpServerColoring": "Enable coloring for the server, meaning that the server can be colored by incoming requests and return the color on its responses",
        "httpClientColoring": "Enable coloring for the client, meaning that the client can be colored by responses from the server and send colors for outgoing requests",
        "useslnode2": "Use the new version of the sl-node2. Experimental. Requires installing sl-node2 and istanbul manually.",
        "uniqueModuleId": "Unique module id, case-sensitive. This value should remain consistent between runs.",
        "downloadAgent": "Set this value to 'false' in order to prevent the instrumented javascript to try and download the browser test listener (for example, when using 'Karma').",
        "es6Modules": "Use ES6 'module' mode when scanning files.",
        "useBabylon": "Use babylon for scanning files",
        "instrumentationOnly": "When provided with 'instrumentForBrowsers', prevents a new build from being reported to Sealights.",
        "instrumentForBrowsers": "Use this in order to instrument the javascript for working with the browser test listener.",
        "sendContributors": "Send contributor details for advanced committer reports and features",
        "delayShutdownInSeconds": "Shutdown time in seconds for the browser agent. Default is 30 seconds.",
        "shouldSetEnv": "Should override NODE_ENV value. ",
        "nodeEnvValue": "Values used when override NODE_ENV value, separated by comma",
        "skipUpgrade": "Should not try to upgrade agent",
        "scmProvider": "The provider name of your Source Control Management (SCM) tool. Supported values are 'Github', 'Bitbucket' and 'Gitlab'. If not used, 'Github' is assumed.",
        "scmVersion": "The version of your Source Control Management (SCM) tool. If left blank, cloud version is assumed. Otherwise, specify the version of your on-premise server.",
        "scmBaseUrl": "The URL to the repository which contains the code. If left blank, the url of the remote GIT origin is being used.",
        "babylonPlugins": "List of non default babylon parser plugins, separated by comma. (list of plugins: https://github.com/babel/babel/tree/master/packages/babylon#plugins)",
        "nycReport": "Path to the relevant nyc json report.",
        "projectRoot": "Determine the root directory of project, default is current working directory",
        "repositoryUrl": "Repository url of the target branch",
        "pullRequestNumber": "Pull request number",
        "latestCommit": "Head SHA of the pull request source",
        "targetBranch": "Target branch of the pull request",
        "userDefinedBuildSessionId": "Provide build session id manually",
        "enforceFullRun": "Overrides test selection configuration"
    };
    var NonUpdateCommands;
    (function (NonUpdateCommands) {
        NonUpdateCommands["INSTALL_BABEL"] = "installBabel";
        NonUpdateCommands["CONFIG"] = "config";
        NonUpdateCommands["RESTORE"] = "restore";
        NonUpdateCommands["HELP"] = "-h";
    })(NonUpdateCommands || (NonUpdateCommands = {}));
    var logger = logger_1.LoggerFactory.getCreateApplicationLogger();
    var version = packageFile.version;
    var packageName = packageFile.name || "slnodejs";
    var program = new custom_commander_1.CustomCommander().getCommander();
    var upgradeManager = new upgrade_manager_1.UpgradeManager(packageName, logger);
    var cmd = parseArgs();
    var processArgs = process.argv.slice(1, process.argv.length);
    var execArgv = process.execArgv;
    var environmentParams = new environment_params_1.EnvironmentParams();
    var cwd = environmentParams.getBasePath();
    var utils = new utils_1.Utils();
    var userMessageHelper = new user_message_helper_1.UserMessageHelper("slnodejs");
    if (!cmd.skipUpgrade) {
        runUpgrade();
    }
    else {
        runCli();
    }
    function runUpgrade() {
        upgradeManager.verifyLastVersionInstalled(cmd, version).then(function (shouldRestartSlnodejs) {
            if (!shouldRestartSlnodejs) {
                runCli();
            }
            else {
                logger.info("Recommended version downloaded. Restarting slnodejs.");
                restartSlnodejs();
            }
        }).catch(function (err) {
            userMessageHelper.printError("Error while trying to upgrade slnodejs. Error: " + err + ". \n " +
                "Skipping sealights integration.");
        });
    }
    ;
    function runCli() {
        program.version(version);
        program
            .command("config")
            .description("Configure Agent")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            .option("--buildsessionid <buildsessionid>", options.userDefinedBuildSessionId)
            .option("--proxy <proxy>", options.proxy)
            .option("--failbuild <failbuild>", options.failbuild, false)
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            return __awaiter(this, void 0, void 0, function () {
                var bsidCreator, e_1, exitCode;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            bsidCreator = new build_session_id_creator_1.BuildSessionIdCreator(cmd);
                            return [4 /*yield*/, bsidCreator.createBuildSessionId()];
                        case 1:
                            _a.sent();
                            process.exit(0);
                            return [3 /*break*/, 3];
                        case 2:
                            e_1 = _a.sent();
                            logger.error("Failed to create buildSessionId, '" + e_1);
                            exitCode = cmd.failbuild ? 1 : 0;
                            process.exit(exitCode);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        });
        program
            .command("prConfig")
            .description("Create buildSessionId for pull request integration")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            .option("--targetBranch <targetBranch>", options.targetBranch)
            .option("--latestCommit <latestCommit>", options.latestCommit)
            .option("--pullRequestNumber <pullRequestNumber>", options.pullRequestNumber)
            .option("--repositoryUrl <repositoryUrl>", options.repositoryUrl)
            .option("--buildsessionid <buildsessionid>", options.userDefinedBuildSessionId)
            .option("--proxy <proxy>", options.proxy)
            .option("--failbuild <failbuild>", options.failbuild, false)
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            return __awaiter(this, void 0, void 0, function () {
                var bsidCreator, e_2, exitCode;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            bsidCreator = new pr_build_session_id_creator_1.PrBuildSessionIdCreator(cmd);
                            return [4 /*yield*/, bsidCreator.createBuildSessionId()];
                        case 1:
                            _a.sent();
                            process.exit(0);
                            return [3 /*break*/, 3];
                        case 2:
                            e_2 = _a.sent();
                            logger.error("Failed to create buildSessionId, '" + e_2);
                            exitCode = cmd.failbuild ? 1 : 0;
                            process.exit(exitCode);
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        });
        program
            .command("build")
            .description("Run Build Scanner")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            .option("--usebranchcoverage [usebranchcoverage]", options.usebranchcoverage, utils.booleanOption, true)
            // build specific options
            .option("--workspacepath <workspacepath>", options.workspacepath)
            .option("--excludedpaths <excludedpaths>", options.excludedpaths)
            .option("--jobName <jobName>", options.jobName)
            .option("--logsUrl <logsUrl>", options.logsUrl)
            .option("--commit  <commit>", options.commit)
            .option("--scm <scm>", options.scm)
            .option("--proxy <proxy>", options.proxy)
            .option("--dependency <dependency>", options.dependency)
            .option("-d, --dependenciesFile <dependenciesFile>", options.dependenciesFile)
            .option("--failbuild <failbuild>", options.failbuild, false)
            .option("--recursive", "recursive", true)
            .option("--instrumentForBrowsers", options.instrumentForBrowsers, false)
            .option("--es6Modules", options.es6Modules, false)
            .option("--useBabylon [useBabylon]", options.useBabylon, utils.booleanOption, true)
            .option("--sendContributors [sendContributors]", options.sendContributors, utils.booleanOption, true)
            .option("--delayShutdownInSeconds <n>", options.delayShutdownInSeconds, parseInt)
            .option("--instrumentationOnly", options.instrumentationOnly, false)
            .option("--resolveWithoutHash [resolveWithoutHash]", "resolveWithoutHash", utils.booleanOption, true)
            .option("--outputpath <outputpath>", "outputpath")
            .option("--uniqueModuleId <uniqueModuleId>", options.uniqueModuleId)
            .option("--downloadAgent <downloadAgent>", options.downloadAgent)
            .option("--scmProvider <scmProvider>", options.scmProvider)
            .option("--scmBaseUrl <scmBaseUrl>", options.scmBaseUrl)
            .option("--scmVersion <scmVersion>", options.scmVersion)
            .option("--babylonPlugins <babylonPlugins>", options.babylonPlugins)
            .option("--projectRoot <projectRoot>", options.projectRoot)
            .option("--labid <labid>", options.labid)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.createBuild(cmd, function (err) {
                var statusCode = 0;
                if (err) {
                    statusCode = err.statusCode;
                }
                process.exit(statusCode);
            });
        });
        program
            .command("mocha [args...]")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            .option("--usebranchcoverage [usebranchcoverage]", options.usebranchcoverage, utils.booleanOption, true)
            // command specific options
            .option("--teststage <teststage>", options.teststage, "Unit Tests")
            .option("--labid <labid>", options.labid, undefined)
            .option("--proxy <proxy>", options.proxy)
            .option("--useslnode2 [useslnode2]", options.useslnode2, utils.booleanOption, true)
            .option("--httpServerColoring", options.httpServerColoring, false)
            .option("--httpClientColoring", options.httpClientColoring, false)
            .option("--resolveWithoutHash [resolveWithoutHash]", "resolveWithoutHash", utils.booleanOption, true)
            .option("--projectRoot <projectRoot>", options.projectRoot)
            .option("--enforceFullRun", options.enforceFullRun, false)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .description("Run Unit Tests with Mocha")
            .action(function (args, cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.runMocha(cmd, args, function (statusCode) {
                process.exit(statusCode);
            });
        });
        program
            .command("jasmine [args...]")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            .option("--usebranchcoverage [usebranchcoverage]", options.usebranchcoverage, utils.booleanOption, true)
            // command specific options
            .option("--teststage <teststage>", options.teststage, "Unit Tests")
            .option("--labid <labid>", options.labid, undefined)
            .option("--proxy <proxy>", options.proxy)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .description("Run tests with jasmine-node")
            .action(function (args, cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.runJasmine(cmd, args);
        });
        program
            .command("mochaPhantomjs [args...]")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // command specific options
            .option("--labid <labid>", options.labid, undefined)
            .option("--resolveWithoutHash [resolveWithoutHash]", "resolveWithoutHash", utils.booleanOption, true)
            // general options
            .option("--failbuild <failbuild>", options.failbuild, false)
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .description("Create 'sl-hooks.js' for integration with mocha-phantomjs")
            .action(function (args, cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.runMochaPhantomJS(cmd, function (statusCode) {
                process.exit(statusCode);
            });
        });
        program
            .command("run [args...]")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            .option("--usebranchcoverage [usebranchcoverage]", options.usebranchcoverage, utils.booleanOption, true)
            // command specific options
            .option("--teststage <teststage>", options.teststage, "Unit Tests")
            .option("--labid <labid>", options.labid, undefined)
            .option("--proxy <proxy>", options.proxy)
            .option("--useinitialcolor <useinitialcolor>", options.useinitialcolor, false)
            .option("--workspacepath <workspacepath>", options.workspacepath, ".")
            .option("--failbuild <failbuild>", options.failbuild, false)
            .option("--useslnode2 [useslnode2]", options.useslnode2, utils.booleanOption, true)
            .option("--httpServerColoring", options.httpServerColoring, false)
            .option("--httpClientColoring", options.httpClientColoring, false)
            .option("--projectRoot <projectRoot>", options.projectRoot)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .description("Run Program with Agent")
            .action(function (args, cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.run(cmd, args, function (err) {
                defaultProcessExit(err, cmd);
            });
        });
        /**
         * Start Execution for the Generic Agent
         */
        program
            .command("start")
            .description("Start Execution")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            // command specific options
            .option("--teststage <teststage>", options.teststage, "Unit Tests")
            .option("--labid <labid>", options.labid, undefined)
            .option("--proxy <proxy>", options.proxy)
            .option("--failbuild <failbuild>", options.failbuild, false)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.startExecution(cmd, function (err) {
                defaultProcessExit(err, cmd);
            });
        });
        /**
         * End Execution for the Generic Agent
         */
        program
            .command("end")
            .description("End Execution")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            // command specific options
            .option("--labid <labid>", options.labid, undefined)
            .option("--proxy <proxy>", options.proxy)
            .option("--failbuild <failbuild>", options.failbuild, false)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.endExecution(cmd, function (err) {
                defaultProcessExit(err, cmd);
            });
        });
        /**
         * Upload Junit Reports for the Generic Agent
         */
        program
            .command("uploadReports")
            .description("Upload Reports")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            // command specific options
            .option("--labid <labid>", options.labid, undefined)
            .option("--reportFile <reportFile>", options.reportFile, utils.csvToArray, [])
            .option("--reportFilesFolder <reportFilesFolder>", options.reportFilesFolder, utils.csvToArray, [])
            .option("--type <type>", options.type, "JUnitReport")
            .option("--source <source>", options.source, "Mocha")
            .option("--hasMoreRequests [hasMoreRequests]", options.hasMoreRequests, utils.booleanOption, true)
            .option("--proxy <proxy>", options.proxy)
            .option("--failbuild <failbuild>", options.failbuild, false)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.uploadReports(cmd, function (err) {
                defaultProcessExit(err, cmd);
            });
        });
        program
            .command("externalReport")
            .description("Upload External Report")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            // build session overwrites
            .option("--appname <appname>", options.appname)
            .option("--branch <branch>", options.branch)
            .option("--build <build>", options.build)
            // command specific options
            .option("--report <report>", options.report)
            .option("--failbuild <failbuild>", options.failbuild, false)
            .option("--proxy <proxy>", options.proxy)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.externalReport(cmd, function (err) {
                defaultProcessExit(err, cmd);
            });
        });
        program
            .command("nycReport")
            .description("Upload nyc report")
            .option("--tokenfile <tokenfile>", options.tokenfile)
            .option("--token <token>", options.token)
            .option("--buildsessionid <buildsessionid>", options.buildsessionid)
            .option("--buildsessionidfile <buildsessionidfile>", options.buildsessionidfile)
            .option("--labid <labid>", options.labid, undefined)
            .option("--proxy <proxy>", options.proxy)
            .option("--report <report>", options.nycReport)
            .option("--projectRoot <projectRoot>", options.projectRoot)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var api = new async_execution_api_1.AsyncExecutionApi();
            api.nycReport(cmd, function (err) {
                if (err) {
                    logger.error("Error while trying to upload nyc report, err: ", err);
                }
                // defaultProcessExit(err, cmd);
            });
        });
        program
            .command("installBabel")
            .description("Set babel config to support sealights")
            .option("--nodeEnvValue <nodeEnvValue>", options.nodeEnvValue, utils.csvToArray)
            // general options
            .option("--skipUpgrade", options.skipUpgrade, utils.booleanOption, false)
            .action(function (cmd) {
            var installationManager = new installation_manager_1.InstallationManager();
            installationManager.updateBabelConfig(cmd, logger);
        });
        program.parse(process.argv);
        if (!process.argv.slice(2).length) {
            program.outputHelp();
            process.exit(1);
        }
        function defaultProcessExit(err, cmd) {
            var statusCode = 0;
            if (err) {
                console.error(err.message);
                statusCode = cmd.failbuild ? 1 : 0;
            }
            process.exit(statusCode);
        }
    }
    function parseArgs() {
        var cmd = {};
        for (var i = 0; i < process.argv.length; i++) {
            if (process.argv[i].startsWith("--")) {
                var key = process.argv[i].substring(2);
                if (process.argv[i + 1] && !process.argv[i + 1].startsWith("--")) {
                    cmd[key] = process.argv[i + 1];
                }
                else {
                    cmd[key] = true;
                }
            }
        }
        var command = process.argv[2];
        cmd.skipUpgrade = cmd.skipUpgrade || shouldSkipUpgradeForCommand(command);
        return cmd;
    }
    function shouldSkipUpgradeForCommand(command) {
        if (!command) {
            return false;
        }
        for (var _i = 0, _a = Object.keys(NonUpdateCommands); _i < _a.length; _i++) {
            var key = _a[_i];
            if (NonUpdateCommands[key] === command) {
                return true;
            }
        }
        return false;
    }
    var restartSlnodejs = function () {
        var child = spawn("node", execArgv.concat(processArgs).concat(["--skipUpgrade"]), { cwd: cwd });
        child.stdout.on('data', function (data) {
            console.log(data.toString());
        });
        child.stderr.on('data', function (data) {
            console.log('stderr: ' + data.toString());
        });
    };
});
//# sourceMappingURL=typed-cli.js.map