var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./utils", "fs", "path", "./npm-manager", "./environment-params", "./file-utils", "./version-exists-wrapper", "./constants", "sl-js-infra", "./agent-instance-data"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils_1 = require("./utils");
    var fs = require("fs");
    var path = require("path");
    var npm_manager_1 = require("./npm-manager");
    var environment_params_1 = require("./environment-params");
    var FileUtils = require("./file-utils");
    var version_exists_wrapper_1 = require("./version-exists-wrapper");
    var constants_1 = require("./constants");
    var sl_js_infra_1 = require("sl-js-infra");
    var agent_instance_data_1 = require("./agent-instance-data");
    /*
        This class verify that recommended version of slnodejs installed, if needed download it.
     */
    var UpgradeManager = /** @class */ (function () {
        function UpgradeManager(packageName, logger) {
            this.utils = new utils_1.Utils();
            this._versionWrapper = new version_exists_wrapper_1.VersionExistsWrapper();
            this.environmentParams = new environment_params_1.EnvironmentParams();
            this.dependencies = [
                "sl-browser-agent",
                "sl-cia",
                "sl-node",
                "sl-node-mocha",
                "sl-node-mocha2",
                "sl-node2"
            ];
            this.packageName = packageName;
            this.logger = logger;
            this._npmManager = new npm_manager_1.NpmManager(logger);
        }
        UpgradeManager.prototype.verifyLastVersionInstalled = function (cmd, version) {
            return __awaiter(this, void 0, void 0, function () {
                var upgradeConfig, shouldUpgrade;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.tryGetUpgradeConfig(cmd)];
                        case 1:
                            upgradeConfig = _a.sent();
                            if (!upgradeConfig) {
                                return [2 /*return*/, false];
                            }
                            return [4 /*yield*/, this.shouldUpgrade(upgradeConfig, version)];
                        case 2:
                            shouldUpgrade = _a.sent();
                            if (shouldUpgrade) {
                                return [2 /*return*/, this.upgrade()];
                            }
                            this.logger.info("Recommended version already installed skipping upgrade.");
                            return [2 /*return*/, false];
                    }
                });
            });
        };
        UpgradeManager.prototype.upgrade = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (this.recommendedVersionResponse.url) {
                        this.logger.info("About to upgrade version to: " + this.recommendedVersionResponse.version + " from file.");
                        return [2 /*return*/, this.installFromFile()];
                    }
                    this.logger.info("About to upgrade version to: " + this.recommendedVersionResponse.version + " from npm.");
                    return [2 /*return*/, this.installFromNpm()];
                });
            });
        };
        UpgradeManager.prototype.installFromNpm = function () {
            return __awaiter(this, void 0, void 0, function () {
                var hasVersion, basePath;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.versionWrapper.checkVersion(this.packageName, this.recommendedVersionResponse.version)];
                        case 1:
                            hasVersion = _a.sent();
                            if (!hasVersion) {
                                this.logger.info("Version dose not exists in npm repository, skipping upgrade");
                                return [2 /*return*/, false];
                            }
                            basePath = this.environmentParams.getBasePath();
                            this._npmManager.removePackages(this.dependencies, basePath);
                            this._npmManager.installSpecificVersion(this.packageName, this.recommendedVersionResponse.version, basePath);
                            this.logger.info("Installing from npm finished successfully");
                            return [2 /*return*/, true];
                    }
                });
            });
        };
        UpgradeManager.prototype.installFromFile = function () {
            return __awaiter(this, void 0, void 0, function () {
                var destFile, basePath;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getSlnodeFile()];
                        case 1:
                            destFile = _a.sent();
                            if (!destFile) {
                                return [2 /*return*/, false];
                            }
                            basePath = this.environmentParams.getBasePath();
                            this.logger.info("Installing slnodejs from: '" + destFile + "'");
                            this._npmManager.removePackages(this.dependencies, basePath);
                            this._npmManager.installFromFile(destFile, basePath);
                            this.logger.info("Installing from file finished successfully");
                            return [2 /*return*/, true];
                    }
                });
            });
        };
        UpgradeManager.prototype.getSlnodeFile = function () {
            return __awaiter(this, void 0, void 0, function () {
                var fileStorage, fileExt, fileName, slnodeFolder, filePath, exist, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            fileStorage = this.environmentParams.getFileStorage();
                            fileExt = this.getFileExtension();
                            fileName = constants_1.Constants.SLNODE_PACKAGE + "-" + this.recommendedVersionResponse.version + fileExt;
                            slnodeFolder = path.join(fileStorage, constants_1.Constants.SL_CACHE_FOLDER, constants_1.Constants.SLNODE_PACKAGE);
                            filePath = path.join(slnodeFolder, fileName);
                            exist = fs.existsSync(filePath);
                            if (!!exist) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            if (!fs.existsSync(slnodeFolder)) {
                                FileUtils.createMultipleDirs(slnodeFolder);
                            }
                            return [4 /*yield*/, FileUtils.downloadFile(this.recommendedVersionResponse.url, filePath, this.logger)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            filePath = null;
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/, filePath];
                    }
                });
            });
        };
        UpgradeManager.prototype.getFileExtension = function () {
            /*
            File url came with http params like access key and expiration i.e 'file.tgz?AccessKey=123', so we take
            the extension without params.
             */
            return path.extname(this.recommendedVersionResponse.url).split("?")[0];
        };
        UpgradeManager.prototype.shouldUpgrade = function (upgradeConfig, currentVersion) {
            return __awaiter(this, void 0, void 0, function () {
                var proxy, _a, err_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 2, , 3]);
                            proxy = new sl_js_infra_1.SlJsInfra.BackendProxy(agent_instance_data_1.agentInstanceData, upgradeConfig, this.logger);
                            _a = this;
                            return [4 /*yield*/, proxy.getRecommendedVersion(upgradeConfig)];
                        case 1:
                            _a.recommendedVersionResponse = _b.sent();
                            this.logger.info("Current version is: " + currentVersion + ", recommended version: " + this.recommendedVersionResponse.version);
                            return [2 /*return*/, currentVersion != this.recommendedVersionResponse.version];
                        case 2:
                            err_1 = _b.sent();
                            this.logger.warn("error while trying to get recommended version, skipping upgrade. error: " + err_1);
                            return [2 /*return*/, false];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        UpgradeManager.prototype.allDependenciesInstalled = function () {
            this.dependencies.forEach(function (dep) {
                var environmentParams = new environment_params_1.EnvironmentParams();
                var dependencyPath = path.join(environmentParams.getBasePath(), "node_modules", dep);
                if (!fs.existsSync(dependencyPath))
                    return false;
            });
            return true;
        };
        UpgradeManager.prototype.tryGetUpgradeConfig = function (cmd) {
            return __awaiter(this, void 0, void 0, function () {
                var buildSessionData, upgradeConfiguration, err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.utils.parseToken(cmd);
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, this.tryGetBuildSessionData(cmd)];
                        case 2:
                            buildSessionData = _a.sent();
                            upgradeConfiguration = this.createUpgradeConfiguration(cmd, buildSessionData);
                            return [2 /*return*/, upgradeConfiguration];
                        case 3:
                            err_2 = _a.sent();
                            this.logger.warn("error while trying to get upgrade configuration, skipping upgrade. error: " + err_2);
                            return [2 /*return*/, null];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        UpgradeManager.prototype.createUpgradeConfiguration = function (cmd, buildSessionData) {
            var upgradeConfig = {
                token: cmd.token,
                server: cmd.server,
                customerId: cmd.customerid,
                appName: buildSessionData.appname,
                buildName: buildSessionData.build,
                branchName: buildSessionData.branch,
                componentName: this.packageName,
                proxy: cmd.proxy || null,
                testStage: cmd.environment || null
            };
            return upgradeConfig;
        };
        UpgradeManager.prototype.tryGetBuildSessionData = function (cmd) {
            var _this = this;
            this.logger.info("[TO AS] Trying to get build session data");
            return new Promise(function (resolve, reject) {
                var buildsessionid = _this.utils.getBuildSession(cmd);
                _this.utils.getBuildSessionParams(buildsessionid, cmd, function (err, buildSessionData) {
                    if (err) {
                        _this.logger.info("[FROM AS] Error while trying to get build session data. " + err);
                        reject(err);
                    }
                    if (buildSessionData) {
                        _this.logger.info("[FROM AS] Got build session data. " + JSON.stringify(buildSessionData));
                        resolve(buildSessionData);
                    }
                });
            });
        };
        Object.defineProperty(UpgradeManager.prototype, "npmManager", {
            get: function () {
                return this._npmManager;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(UpgradeManager.prototype, "versionWrapper", {
            get: function () {
                return this._versionWrapper;
            },
            enumerable: true,
            configurable: true
        });
        return UpgradeManager;
    }());
    exports.UpgradeManager = UpgradeManager;
});
//# sourceMappingURL=upgrade-manager.js.map