(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    /**
     * Created by nadav on 12/03/2017.
     */
    var UserMessageHelper = /** @class */ (function () {
        function UserMessageHelper(prefix, verbose) {
            this.prefix = prefix;
            this.verbose = verbose;
            if (prefix == null)
                throw new Error("'prefix' cannot be null");
        }
        UserMessageHelper.prototype.println = function (text) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var message = this.prefix + " - " + text;
            if (args && args.length > 0) {
                for (var i = 0; i < args.length; i++) {
                    var arg = args[i];
                    if (!arg)
                        continue;
                    if (arg instanceof Error) {
                        message += arg.message + "\n" + arg.stack;
                    }
                    else if (typeof arg === "object") {
                        message += JSON.stringify(arg);
                    }
                    else {
                        message = message + arg.toString();
                    }
                }
            }
            console.log(message);
        };
        UserMessageHelper.prototype.printWarn = function (text) {
            this.println("WARNING - " + text);
        };
        UserMessageHelper.prototype.printError = function (text, error) {
            this.println("ERROR - " + text, error);
        };
        UserMessageHelper.prototype.printDebug = function (text) {
            if (this.verbose) {
                this.println("DEBUG - " + text);
            }
        };
        return UserMessageHelper;
    }());
    exports.UserMessageHelper = UserMessageHelper;
});
//# sourceMappingURL=user-message-helper.js.map